%global _hardened_build 1

Name:           gnokii
Version:        0.6.31
Release:    1%{?dist}
Summary:        Linux/Unix tool suite for various mobile phones

License:        GPL-2.0-or-later
URL:            https://www.gnokii.org/
Source0:        https://www.gnokii.org/download/gnokii/%{name}-%{version}.tar.bz2
Source2:        %{name}-smsd.service
Source3:        %{name}-smsd.sysconfig
Source4:        %{name}-smsd.logrotate
Source5:        %{name}-smsd2mail.sh
Source6:        %{name}-smsd-README.smsd2mail
Patch0:         %{name}-htmlview.patch
Patch1:         %{name}-config.patch
Patch2:         %{name}-0.6.31-sqlite3.patch
Patch3:         %{name}-0.6.31-gcc5.patch
Patch4:         %{name}-0.6.31-gcc7.patch
Patch5: gnokii-configure-c99.patch

BuildRequires:  gcc
BuildRequires:  flex
BuildRequires:  gettext
BuildRequires:  gtk2-devel
BuildRequires:  desktop-file-utils
BuildRequires:  ImageMagick
BuildRequires:  libpq-devel
BuildRequires:  mariadb-connector-c-devel
BuildRequires:  sqlite-devel
BuildRequires:  zlib-devel
BuildRequires:  bluez-libs-devel
BuildRequires:  libusb-compat-0.1-devel
BuildRequires:  libical-devel >= 0.24
BuildRequires:  libXt-devel
BuildRequires:  libXpm-devel 
BuildRequires:  pcsc-lite-devel
BuildRequires:  readline-devel
BuildRequires:  perl(XML::Parser) intltool
BuildRequires:  make
BuildRequires:  chrpath
Requires(pre):  %{_sbindir}/groupadd

%description
Gnokii provides tools and a user space driver for use with mobile
phones under Linux, various unices and Win32. With gnokii you can do
such things as make data calls, update your address book, change
calendar entries, send and receive SMS messages and load ring tones
depending on the phone you have.

%package     -n xgnokii
Summary:        Graphical Linux/Unix tool suite for various mobile phones
Requires:       %{name} = %{version}-%{release}

%description -n xgnokii
Xgnokii is graphical Linux/Unix tool suite for various mobile
phones. It allows you to edit your contacts book, send/read SMS's
from/in computer and more other features.

%package        smsd
Summary:        Gnokii SMS daemon
Requires:       %{name} = %{version}-%{release}
Requires(pre):  %{_sbindir}/useradd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires:  systemd

%description    smsd
The Gnokii SMS daemon receives and sends SMS messages.

%package        smsd-pgsql
Summary:        PostgreSQL support for Gnokii SMS daemon
Requires:       %{name}-smsd = %{version}-%{release}

%description    smsd-pgsql
%{summary}.

%package        smsd-mysql
Summary:        MySQL support for Gnokii SMS daemon
Requires:       %{name}-smsd = %{version}-%{release}

%description    smsd-mysql
%{summary}.

%package        smsd-sqlite
Summary:        SQLite support for Gnokii SMS daemon
Requires:       %{name}-smsd = %{version}-%{release}

%description    smsd-sqlite
%{summary}.

%package        devel
Summary:        Gnokii development files
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig

%description    devel
%{summary}.


%prep
%setup -q
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
install -pm 644 %{SOURCE5} smsd2mail.sh
install -pm 644 %{SOURCE6} README.smsd2mail

%build
%configure --enable-security --disable-static --disable-rpath
sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' -i libtool
sed -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' -i libtool
%make_build
pushd xgnokii
%make_build
popd 

%install
%make_install

mv %{buildroot}%{_bindir}/{,gnokii-}smsd
mv %{buildroot}%{_mandir}/man8/{,gnokii-}smsd.8
sed -i 's,smsd ,gnokii-smsd ,' %{buildroot}%{_mandir}/man8/gnokii-smsd.8
sed -i 's,smsd.,gnokii-smsd.,' %{buildroot}%{_mandir}/man8/gnokii-smsd.8

rm %{buildroot}%{_libdir}{,/smsd}/lib*.la

desktop-file-install \
  --delete-original \
  --vendor "" \
  --dir %{buildroot}%{_datadir}/applications \
  --mode 644 \
  --add-category System \
  xgnokii/xgnokii.desktop

install -D -m 755 xgnokii/.libs/xgnokii %{buildroot}%{_bindir}

install -D -m 644 common/gnokii.pc %{buildroot}%{_libdir}/pkgconfig/gnokii.pc
install -D -m 644 xgnokii/xgnokii.pc %{buildroot}%{_libdir}/pkgconfig/xgnokii.pc

install -dm 755 %{buildroot}%{_datadir}/pixmaps
convert Docs/sample/logo/gnokii.xpm \
  %{buildroot}%{_datadir}/pixmaps/xgnokii.png
chmod 644 %{buildroot}%{_datadir}/pixmaps/xgnokii.png

install -Dpm 644 %{SOURCE2} %{buildroot}%{_unitdir}/gnokii-smsd.service
install -Dpm 640 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/gnokii-smsd
install -Dpm 644 %{SOURCE4} \
  %{buildroot}%{_sysconfdir}/logrotate.d/gnokii-smsd
cp -a Docs/sample/gnokiirc %{buildroot}%{_sysconfdir}/

mv %{buildroot}%{_datadir}/doc/gnokii/ temporary-gnokii-docs/

chrpath --delete %{buildroot}%{_bindir}/{gnokii,gnokiid,gnokii-smsd,xgnokii}

%find_lang %{name}

%pre
getent group %{name} > /dev/null || %{_sbindir}/groupadd -r %{name}

%pre smsd
getent passwd %{name} > /dev/null || %{_sbindir}/useradd -r -M -d / \
  -g %{name} -s /sbin/nologin -c "Gnokii system user" %{name}


%post smsd
%systemd_post gnokii-smsd.service

%preun smsd
%systemd_preun gnokii-smsd.service

%postun smsd
%systemd_postun_with_restart gnokii-smsd.service

%files -f %{name}.lang
%license COPY*
%doc ChangeLog MAINTAINERS TODO temporary-gnokii-docs/*
%config(noreplace) %{_sysconfdir}/gnokiirc
%attr(4750,root,gnokii) %{_sbindir}/mgnokiidev
%{_bindir}/gnokii
%{_bindir}/sendsms
%{_bindir}/gnokiid
%{_libdir}/libgnokii.so.*
%{_mandir}/man1/gnokii.1*
%{_mandir}/man1/sendsms.1*
%{_mandir}/man8/gnokiid.8*
%{_mandir}/man8/mgnokiidev.8*

%files -n xgnokii
%doc xgnokii/ChangeLog xgnokii/README.vcard
%{_bindir}/xgnokii
%{_datadir}/pixmaps/xgnokii.png
%{_datadir}/applications/*xgnokii.desktop
%{_mandir}/man1/xgnokii.1*

%files smsd
%doc smsd/action smsd/ChangeLog smsd/README README.smsd2mail smsd2mail.sh
%attr(-,gnokii,gnokii) %config(noreplace) %{_sysconfdir}/sysconfig/gnokii-smsd
%config(noreplace) %{_sysconfdir}/logrotate.d/gnokii-smsd
%{_unitdir}/gnokii-smsd.service
%{_bindir}/gnokii-smsd
%{_mandir}/man8/gnokii-smsd.8*
%dir %{_libdir}/smsd/
%{_libdir}/smsd/libsmsd_file.so

%files smsd-pgsql
%doc smsd/sms.tables.pq.sql
%{_libdir}/smsd/libsmsd_pq.so

%files smsd-mysql
%doc smsd/sms.tables.mysql.sql
%{_libdir}/smsd/libsmsd_mysql.so

%files smsd-sqlite
%doc smsd/sms.tables.sqlite.sql
%{_libdir}/smsd/libsmsd_sqlite.so

%files devel
%{_includedir}/gnokii*
%{_libdir}/libgnokii.so
%{_libdir}/pkgconfig/gnokii.pc
%{_libdir}/pkgconfig/xgnokii.pc

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.6.31-1
- initial build
